unit APakka;
{
  Animoitu pakka-komponentti:
  - Omaa yleisen pakan ominaisuudet
  - Siirt kortin "lentmll"
  AJakoPakka-komponentti:
   - sislt kaikki kortit jo syntyessn

  8.11.1997/ Vesa Lappalainen
  Muutoksia:

  11.11.1997 / vl
   + listty testi siit, ettei nil-kortti aiheuta ongelmia
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,StdCtrls,kortti,pakka;

type
  TAPakka = class(TPakka)
  private
    FSpeed : integer;
  protected
  public
    procedure Arrive(o:TControl; i:integer);            virtual;
    procedure lisaa_paikkaan(i:integer;kortti:TKortti); override;
  published
    property Speed : integer read FSpeed write FSpeed default 0;
  end;

type
  TAJakoPakka = class(TJakoPakka)
  private
    FSpeed : integer;
  protected
  public
    procedure Arrive(o:TControl; i:integer);            virtual;
    procedure lisaa_paikkaan(i:integer;kortti:TKortti); override;
  published
    property Speed : integer read FSpeed write FSpeed default 0;
  end;

procedure Register;

implementation
uses liikkuva;


procedure TAPakka.Arrive(o:TControl; i:integer);
begin
  if not ( o is TKortti ) then exit;
  inherited lisaa_paikkaan(i,o as TKortti);
end;

procedure TAPakka.lisaa_paikkaan(i:integer;kortti:TKortti);
begin
  if ( kortti = nil ) then exit;
  if ( kortti.Parent = nil ) or ( kortti.Parent = self ) then begin
    inherited lisaa_paikkaan(i,kortti);
    exit;
  end;
  kortti.Visible := true;
  Kuljeta(kortti,self,Arrive,i,Speed);
end;


//---------------------------------------------------------------------
// Jakopakan omat metodit:

procedure TAJakoPakka.Arrive(o:TControl; i:integer);
begin
  if not ( o is TKortti ) then exit;
  inherited lisaa_paikkaan(i,o as TKortti);
end;

procedure TAJakoPakka.lisaa_paikkaan(i:integer;kortti:TKortti);
begin
  if ( kortti = nil ) then exit;
  if ( kortti.Parent = nil ) or ( kortti.Parent = self ) then begin
    inherited lisaa_paikkaan(i,kortti);
    exit;
  end;
  kortti.Visible := true;
  Kuljeta(kortti,self,Arrive,i,Speed);
end;


procedure Register;
begin
  RegisterComponents('GKO97', [TAPakka,TAJakoPakka]);
end;

end.
