unit EventMsg;
{
  Olio, joka tehty helpottamaan viivstetyn metodin kutsumista.
  Vesa Lappalainen 11.11.1997

  Kytt:
    Kirjoita WinControlliin (esim. formille) metodi, jolla on parametrina
    yksi TObject. (Esim. procedure MyEvent(o:TObject);)

    Jos ko. metodin kutsu pit saada suoritettua vasta kun kaikki
    viestijonossa olevat muut viestit on ksitelty, kutsu metodia:
      DoPostEvent(self,MyEvent,MyData);
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Dialogs,
  ExtCtrls,StdCtrls;

const WM_POSTEVENTMSG = WM_USER + 12;
type
  TEventMethod = procedure (o:TObject) of object;

  TEventObject = class(TWinControl)
  private
    meth : TEventMethod;
    o : TObject;
  public
    constructor Create3(AOwner:TWinControl;meth:TEventMethod;o:TObject); virtual;
    procedure WmPostEventMsg(var Message: TMessage); message WM_POSTEVENTMSG;
  end;

procedure DoPostEvent(AOwner:TWinControl;meth:TEventMethod;o:TObject);

implementation

constructor TEventObject.Create3(AOwner:TWinControl;meth:TEventMethod;o:TObject);
begin
  inherited Create(AOwner);
  self.meth := meth;
  self.o    := o;
  self.Parent := AOwner as TWinControl;
end;

procedure TEventObject.WmPostEventMsg(var Message: TMessage);
begin
  meth(o);
  Free;
end;

procedure DoPostEvent(AOwner:TWinControl;meth:TEventMethod;o:TObject);
var e:TEventObject;
begin
  e := TEventObject.Create3(AOwner,meth,o);
  PostMessage(e.Handle,WM_POSTEVENTMSG,0,0);
end;


end.
