unit NapoHaut;
{
   Example program for playing pasianss Napoleon's grave.

   Author:  Vesa Lappalainen
   Date:    17.1.1998
   Changes: 

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, Poyta, Pakka, APakka, raahausp, SaantoP,kortti;

type
  TFormNapo = class(TForm)
    Poyta: TPoyta;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    New1: TMenuItem;
    Panel1: TPanel;
    IJakoPakka: TImage;
    KasiPakka: TSaantoPakka;
    Pakka6: TSaantoPakka;
    Pakka7_3: TSaantoPakka;
    PakkaApu_1: TSaantoPakka;
    Pakka7_1: TSaantoPakka;
    PakkaApu_2: TSaantoPakka;
    PakkaKeski: TSaantoPakka;
    PakkaApu_4: TSaantoPakka;
    Pakka7_4: TSaantoPakka;
    PakkaApu_3: TSaantoPakka;
    Pakka7_2: TSaantoPakka;
    Help1: TMenuItem;
    About1: TMenuItem;
    JakoPakka: TAJakoPakka;
    procedure IJakoPakkaClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure JakoPakkaFull(sender: TPakka; i: Integer; k: TKortti);
    procedure JakoPakkaInsert(sender: TPakka; i: Integer; k: TKortti);
    procedure PakkaFull(sender: TPakka; i: Integer; k: TKortti);
  private
    { Private declarations }
    procedure siivoa_pakka(p:TPakka);
  public
    { Public declarations }
    procedure UusiPeli;
  end;

var
  FormNapo: TFormNapo;

implementation

uses aboutnap;

{$R *.DFM}

procedure TFormNapo.FormCreate(Sender: TObject);
begin
  Randomize;
  JakoPakka.Sekoita;
end;

procedure TFormNapo.siivoa_pakka(p:TPakka);
begin
//  JakoPakka.siirra(p);  // Hyv mutta lhtevt liian kki
  if ( p.kortteja <> 0 ) then
    JakoPakka.lisaa_kortti(p.anna_kortti);
end;

procedure TFormNapo.UusiPeli;
begin
  Poyta.ForEveryPakka(siivoa_pakka);
  JakoPakka.siirra(Pakka6);
  JakoPakka.siirra(KasiPakka);
end;


procedure TFormNapo.IJakoPakkaClick(Sender: TObject);
begin
  KasiPakka.lisaa_kortti(JakoPakka.anna_kortti);
end;

procedure TFormNapo.About1Click(Sender: TObject);
begin
   AboutBox.ShowModal;
end;

procedure TFormNapo.New1Click(Sender: TObject);
begin
  UusiPeli;
end;

procedure TFormNapo.JakoPakkaFull(sender: TPakka; i: Integer; k: TKortti);
begin
  JakoPakka.Sekoita;
end;

procedure TFormNapo.JakoPakkaInsert(sender: TPakka; i: Integer;
  k: TKortti);
begin
  if JakoPakka.Kortteja <> 52 then
    UusiPeli;
end;

procedure TFormNapo.PakkaFull(sender: TPakka; i: Integer; k: TKortti);
begin
  sender.Puoli := selka;
end;

end.
